<?php
/**
 * Motivational Speaker functions and definitions
 *
 * @subpackage Motivational Speaker
 * @since 1.0
 */

//theme setup
function motivational_speaker_setup() {
	add_theme_support( 'woocommerce' );
	add_theme_support( "align-wide" );
	add_theme_support( "wp-block-styles" );
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'post-thumbnails' );
	add_theme_support( "responsive-embeds" );
	add_theme_support( 'title-tag' );
	add_theme_support('custom-background',array(
		'default-color' => 'ffffff',
	));
	add_image_size( 'motivational-speaker-featured-image', 2000, 1200, true );
	add_image_size( 'motivational-speaker-thumbnail-avatar', 100, 100, true );

	load_theme_textdomain( 'motivational-speaker', get_template_directory() . '/languages' );

	$GLOBALS['content_width'] = 525;
	register_nav_menus( array(
		'primary' => __( 'Primary Menu', 'motivational-speaker' ),
	) );

	add_theme_support( 'html5', array(
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );

	// Add theme support for Custom Logo.
	add_theme_support( 'custom-logo', array(
		'width'       => 250,
		'height'      => 250,
		'flex-width'  => true,
		'flex-height' => true,
	) );
	/*
	 * Enable support for Post Formats.
	 *
	 * See: https://codex.wordpress.org/Post_Formats
	 */
	add_theme_support( 'post-formats', array('image','video','gallery','audio','quote',) );

	// Add theme support for selective refresh for widgets.
	add_theme_support( 'customize-selective-refresh-widgets' );

	/*
	 * This theme styles the visual editor to resemble the theme style,
	 * specifically font, colors, and column width.
 	 */
	add_editor_style( array( 'assets/css/editor-style.css', motivational_speaker_fonts_url() ) );

	if ( ! defined( 'MOTIVATIONAL_SPEAKER_SUPPORT' ) ) {
	define('MOTIVATIONAL_SPEAKER_SUPPORT',__('https://wordpress.org/support/theme/motivational-speaker/','motivational-speaker'));
	}
	if ( ! defined( 'MOTIVATIONAL_SPEAKER_REVIEW' ) ) {
		define('MOTIVATIONAL_SPEAKER_REVIEW',__('https://wordpress.org/support/theme/motivational-speaker/reviews/','motivational-speaker'));
	}
	if ( ! defined( 'MOTIVATIONAL_SPEAKER_LIVE_DEMO' ) ) {
	define('MOTIVATIONAL_SPEAKER_LIVE_DEMO',__('https://trial.ovationthemes.com/motivational-speaker/','motivational-speaker'));
	}
	if ( ! defined( 'MOTIVATIONAL_SPEAKER_BUY_PRO' ) ) {
	define('MOTIVATIONAL_SPEAKER_BUY_PRO',__('https://www.ovationthemes.com/products/motivational-speaker-wordpress-theme','motivational-speaker'));
	}
	if ( ! defined( 'MOTIVATIONAL_SPEAKER_PRO_DOC' ) ) {
	define('MOTIVATIONAL_SPEAKER_PRO_DOC',__('https://trial.ovationthemes.com/docs/ot-motivational-speaker-pro-doc/','motivational-speaker'));
	}
	if ( ! defined( 'MOTIVATIONAL_SPEAKER_FREE_DOC' ) ) {
	define('MOTIVATIONAL_SPEAKER_FREE_DOC',__('https://trial.ovationthemes.com/docs/ot-motivational-speaker-free-doc/','motivational-speaker'));
	}
	if ( ! defined( 'MOTIVATIONAL_SPEAKER_THEME_NAME' ) ) {
	define('MOTIVATIONAL_SPEAKER_THEME_NAME',__('Premium Motivational Speaker Theme','motivational-speaker'));
	}
	if ( ! defined( 'MOTIVATIONAL_SPEAKER_BUNDLE_LINK' ) ) {
	define('MOTIVATIONAL_SPEAKER_BUNDLE_LINK',__('https://www.ovationthemes.com/products/wordpress-bundle','motivational-speaker'));
	}
	require get_template_directory() . '/inc/dashboard/dashboard-settings.php';
}
add_action( 'after_setup_theme', 'motivational_speaker_setup' );

//woocommerce//
//shop page no of columns
function motivational_speaker_woocommerce_loop_columns() {
	
	$retrun = get_theme_mod( 'motivational_speaker_archieve_item_columns', 3 );
    
    return $retrun;
}
add_filter( 'loop_shop_columns', 'motivational_speaker_woocommerce_loop_columns' );
function motivational_speaker_woocommerce_products_per_page() {

		$retrun = get_theme_mod( 'motivational_speaker_archieve_shop_perpage', 6 );
    
    return $retrun;
}
add_filter( 'loop_shop_per_page', 'motivational_speaker_woocommerce_products_per_page' );
// related products
function motivational_speaker_related_products_args( $args ) {
    $defaults = array(
        'posts_per_page' => get_theme_mod( 'motivational_speaker_related_shop_perpage', 3 ),
        'columns'        => get_theme_mod( 'motivational_speaker_related_item_columns', 3),
    );

    $args = wp_parse_args( $defaults, $args );

    return $args;
}
add_filter( 'woocommerce_output_related_products_args', 'motivational_speaker_related_products_args' );

// breadcrumb seperator
function motivational_speaker_woocommerce_breadcrumb_separator($motivational_speaker_defaults) {
    $motivational_speaker_separator = get_theme_mod('woocommerce_breadcrumb_separator', ' / ');

    // Update the separator
    $motivational_speaker_defaults['delimiter'] = $motivational_speaker_separator;

    return $motivational_speaker_defaults;
}
add_filter('woocommerce_breadcrumb_defaults', 'motivational_speaker_woocommerce_breadcrumb_separator');

//add animation class
if ( class_exists( 'WooCommerce' ) ) { 
	add_filter('post_class', function($motivational_speaker_classes, $class, $product_id) {
	    if( is_shop() || is_product_category() ){
	        
	        $motivational_speaker_classes = array_merge(['wow','zoomIn'], $motivational_speaker_classes);
	    }
	    return $motivational_speaker_classes;
	},10,3);
}

//woocommerce-end//

// Get start function

// Enqueue scripts and styles
function motivational_speaker_enqueue_admin_script($hook) {
    // Admin JS
    wp_enqueue_script('motivational-speaker-admin-js', get_theme_file_uri('/assets/js/motivational-speaker-admin.js'), array('jquery'), true);
    wp_localize_script(
		'motivational-speaker-admin-js',
		'motivational_speaker',
		array(
			'admin_ajax'	=>	admin_url('admin-ajax.php'),
			'wpnonce'			=>	wp_create_nonce('motivational_speaker_dismissed_notice_nonce')
		)
	);
	wp_enqueue_script('motivational-speaker-admin-js');

    wp_localize_script( 'motivational-speaker-admin-js', 'motivational_speaker_scripts_localize',
        array( 'ajax_url' => admin_url( 'admin-ajax.php' ) )
    );
}
add_action('admin_enqueue_scripts', 'motivational_speaker_enqueue_admin_script');

//dismiss function 
add_action( 'wp_ajax_motivational_speaker_dismissed_notice_handler', 'motivational_speaker_ajax_notice_dismiss_fuction' );

function motivational_speaker_ajax_notice_dismiss_fuction() {
	if (!wp_verify_nonce($_POST['wpnonce'], 'motivational_speaker_dismissed_notice_nonce')) {
		exit;
	}
    if ( isset( $_POST['type'] ) ) {
        $type = sanitize_text_field( wp_unslash( $_POST['type'] ) );
        update_option( 'dismissed-' . $type, TRUE );
    }
}

function motivational_speaker_excerpt_enabled(){
	if(get_theme_mod('motivational_speaker_blog_meta_content') == 'Excerpt Content' ) {
		return true;
	}
	return false;
}

/* Excerpt Limit Begin */
function motivational_speaker_string_limit_words($string, $word_limit) {
	$words = explode(' ', $string, ($word_limit + 1));
	if(count($words) > $word_limit)
	array_pop($words);
	return implode(' ', $words);
}

//get start box
function motivational_speaker_custom_admin_notice() {
    // Check if the notice is dismissed
    if ( ! get_option('dismissed-get_started_notice', FALSE ) )  {
        // Check if not on the theme documentation page
        $motivational_speaker_current_screen = get_current_screen();
        $motivational_speaker_theme = wp_get_theme();
        $motivational_speaker_theme_name = strtolower( preg_replace( '#[^a-zA-Z]#', '', $motivational_speaker_theme->get( 'Name' ) ) );
		$motivational_speaker_demo_page_slug = apply_filters( $motivational_speaker_theme_name . '_theme_setup_wizard_motivational_speaker_page_slug', $motivational_speaker_theme_name . '-wizard' );
		$motivational_speaker_expected_screen_id = 'appearance_page_' . $motivational_speaker_demo_page_slug;
        if ( $motivational_speaker_current_screen && $motivational_speaker_current_screen->id !== $motivational_speaker_expected_screen_id ) { ?>
            <div class="notice notice-info is-dismissible" data-notice="get_started_notice">
                <div class="notice-div">
                    <div>
                        <p class="theme-name"><?php echo esc_html($motivational_speaker_theme->get('Name')); ?></p>
                        <p><?php _e('For information and detailed instructions, check out our theme documentation.', 'motivational-speaker'); ?></p>
                    </div>
                    <div class="notice-buttons-box">
                        <a class="button-primary livedemo" href="<?php echo esc_url( MOTIVATIONAL_SPEAKER_LIVE_DEMO ); ?>" target="_blank"><?php esc_html_e('Live Demo', 'motivational-speaker'); ?></a>
                        <a class="button-primary buynow" href="<?php echo esc_url( MOTIVATIONAL_SPEAKER_BUY_PRO ); ?>" target="_blank"><?php esc_html_e('Get Pro Theme', 'motivational-speaker'); ?></a>
                        <a class="button-primary theme-install" href="<?php echo esc_url( 'themes.php?page=' . $motivational_speaker_demo_page_slug ); ?>"><?php _e( 'Begin Installation', 'motivational-speaker' ); ?></a>
                    </div>
                </div>
            </div>
        <?php
        }
    }
}
add_action('admin_notices', 'motivational_speaker_custom_admin_notice');

//after switch theme
add_action('after_switch_theme', 'motivational_speaker_after_switch_theme');
function motivational_speaker_after_switch_theme () {
    update_option('dismissed-get_started_notice', FALSE );
}
//get-start-function-end//

// tag count
function motivational_speaker_display_post_tag_count() {
    $motivational_speaker_tags = get_the_tags();
    $motivational_speaker_tag_count = ($motivational_speaker_tags) ? count($motivational_speaker_tags) : 0;
    $motivational_speaker_tag_text = ($motivational_speaker_tag_count === 1) ? 'tag' : 'tags';
    echo $motivational_speaker_tag_count . ' ' . $motivational_speaker_tag_text;
}

// Date formatting
function motivational_speaker_display_shop_date() {
    // Get the date type option
    $motivational_speaker_date_type = get_theme_mod( 'motivational_speaker_date_type', 'published' );

    // Determine the date to display based on the type
    if ( $motivational_speaker_date_type === 'modified' && get_the_modified_time( 'U' ) !== get_the_time( 'U' ) ) {
        $motivational_speaker_date_to_display = get_the_modified_date( get_option( 'date_format' ) );
    } else {
        $motivational_speaker_date_to_display = get_the_date( get_option( 'date_format' ) );
    }

    // Output the date HTML

    echo esc_html( $motivational_speaker_date_to_display );
}

//media post format
function motivational_speaker_get_media($motivational_speaker_type = array()){
	$motivational_speaker_content = apply_filters( 'the_content', get_the_content() );
  	$output = false;

  // Only get media from the content if a playlist isn't present.
  if ( false === strpos( $motivational_speaker_content, 'wp-playlist-script' ) ) {
    $output = get_media_embedded_in_content( $motivational_speaker_content, $motivational_speaker_type );
    return $output;
  }
}

// front page template
function motivational_speaker_front_page_template( $template ) {
	return is_home() ? '' : $template;
}
add_filter( 'frontpage_template',  'motivational_speaker_front_page_template' );

// excerpt function
function motivational_speaker_custom_excerpt() {
    $motivational_speaker_excerpt = get_the_excerpt();
    $motivational_speaker_plain_text_excerpt = wp_strip_all_tags($motivational_speaker_excerpt);
    
    // Get dynamic word limit from theme mod
    $motivational_speaker_word_limit = esc_attr(get_theme_mod('motivational_speaker_post_excerpt', '30'));
    
    // Limit the number of words
    $motivational_speaker_limited_excerpt = implode(' ', array_slice(explode(' ', $motivational_speaker_plain_text_excerpt), 0, $motivational_speaker_word_limit));

    echo esc_html($motivational_speaker_limited_excerpt);
}

// typograpgy
function motivational_speaker_fonts_scripts() {
	$headings_font = esc_html(get_theme_mod('motivational_speaker_headings_text'));
	$body_font = esc_html(get_theme_mod('motivational_speaker_body_text'));

	if( $headings_font ) {
		wp_enqueue_style( 'motivational-speaker-headings-fonts', '//fonts.googleapis.com/css?family='. $headings_font );
	} else {
		wp_enqueue_style( 'motivational-speaker-be-vietnam', '//fonts.googleapis.com/css2?family=Be+Vietnam+Pro:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900');
	}
	if( $body_font ) {
		wp_enqueue_style( 'motivational-speaker-body-fonts', '//fonts.googleapis.com/css?family='. $body_font );
	} else {
		wp_enqueue_style( 'motivational-speaker-be-vietnam', '//fonts.googleapis.com/css2?family=Be+Vietnam+Pro:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900');
	}
}
add_action( 'wp_enqueue_scripts', 'motivational_speaker_fonts_scripts' );

// Footer Text
function motivational_speaker_copyright_link() {
    $motivational_speaker_footer_text = get_theme_mod('motivational_speaker_footer_text', esc_html__('Motivational Speaker WordPress Theme', 'motivational-speaker'));
    $motivational_speaker_credit_link = esc_url('https://www.ovationthemes.com/products/free-motivational-speaker-wordpress-theme');

    echo '<a href="' . $motivational_speaker_credit_link . '" target="_blank">' . esc_html($motivational_speaker_footer_text) . '<span class="footer-copyright">' . esc_html__(' By Ovation Themes', 'motivational-speaker') . '</span></a>';
}

// custom sanitizations
// dropdown
function motivational_speaker_sanitize_dropdown_pages( $page_id, $setting ) {
	$page_id = absint( $page_id );
	return ( 'publish' == get_post_status( $page_id ) ? $page_id : $setting->default );
}
// slider custom control
if ( ! function_exists( 'motivational_speaker_sanitize_integer' ) ) {
	function motivational_speaker_sanitize_integer( $input ) {
		return (int) $input;
	}
}
// range contol
function motivational_speaker_sanitize_number_absint( $number, $setting ) {

	// Ensure input is an absolute integer.
	$number = absint( $number );

	// Get the input attributes associated with the setting.
	$atts = $setting->manager->get_control( $setting->id )->input_attrs;

	// Get minimum number in the range.
	$min = ( isset( $atts['min'] ) ? $atts['min'] : $number );

	// Get maximum number in the range.
	$max = ( isset( $atts['max'] ) ? $atts['max'] : $number );

	// Get step.
	$step = ( isset( $atts['step'] ) ? $atts['step'] : 1 );

	// If the number is within the valid range, return it; otherwise, return the default
	return ( $min <= $number && $number <= $max && is_int( $number / $step ) ? $number : $setting->default );
}
// select post page
function motivational_speaker_sanitize_select( $input, $setting ){
    $input = sanitize_key($input);
    $choices = $setting->manager->get_control( $setting->id )->choices;
    return ( array_key_exists( $input, $choices ) ? $input : $setting->default );
}
// toggle switch
function motivational_speaker_callback_sanitize_switch( $value ) {
	// Switch values must be equal to 1 of off. Off is indicator and should not be translated.
	return ( ( isset( $value ) && $value == 1 ) ? 1 : 'off' );
}
//choices control
function motivational_speaker_sanitize_choices( $input, $setting ) {
    global $wp_customize;
    $control = $wp_customize->get_control( $setting->id );
    if ( array_key_exists( $input, $control->choices ) ) {
        return $input;
    } else {
        return $setting->default;
    }
}
// phone number
function motivational_speaker_sanitize_phone_number( $phone ) {
  return preg_replace( '/[^\d+]/', '', $phone );
}
// Sanitize Sortable control.
function motivational_speaker_sanitize_sortable( $val, $setting ) {
	if ( is_string( $val ) || is_numeric( $val ) ) {
		return array(
			esc_attr( $val ),
		);
	}
	$sanitized_value = array();
	foreach ( $val as $item ) {
		if ( isset( $setting->manager->get_control( $setting->id )->choices[ $item ] ) ) {
			$sanitized_value[] = esc_attr( $item );
		}
	}
	return $sanitized_value;
}

//widgets
function motivational_speaker_widgets_init() {
	register_sidebar( array(
		'name'          => __( 'Sidebar', 'motivational-speaker' ),
		'id'            => 'sidebar-1',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'motivational-speaker' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Page Sidebar', 'motivational-speaker' ),
		'id'            => 'sidebar-2',
		'description'   => __( 'Add widgets here to appear in your pages and posts', 'motivational-speaker' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Sidebar 3', 'motivational-speaker' ),
		'id'            => 'sidebar-3',
		'description'   => __( 'Add widgets here to appear in your sidebar on blog posts and archive pages.', 'motivational-speaker' ),
		'before_widget' => '<section id="%1$s" class="widget wow zoomIn %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<div class="widget_container"><h3 class="widget-title">',
		'after_title'   => '</h3></div>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 1', 'motivational-speaker' ),
		'id'            => 'footer-1',
		'description'   => __( 'Add widgets here to appear in your footer.', 'motivational-speaker' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 2', 'motivational-speaker' ),
		'id'            => 'footer-2',
		'description'   => __( 'Add widgets here to appear in your footer.', 'motivational-speaker' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 3', 'motivational-speaker' ),
		'id'            => 'footer-3',
		'description'   => __( 'Add widgets here to appear in your footer.', 'motivational-speaker' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );

	register_sidebar( array(
		'name'          => __( 'Footer 4', 'motivational-speaker' ),
		'id'            => 'footer-4',
		'description'   => __( 'Add widgets here to appear in your footer.', 'motivational-speaker' ),
		'before_widget' => '<section id="%1$s" class="widget %2$s">',
		'after_widget'  => '</section>',
		'before_title'  => '<h3 class="widget-title">',
		'after_title'   => '</h3>',
	) );
}
add_action( 'widgets_init', 'motivational_speaker_widgets_init' );

//google fonts
function motivational_speaker_fonts_url(){
	$font_url = '';
	$font_family = array();
	$font_family[] = 'Inter:wght@100;200;300;400;500;600;700;800;900';

	$query_args = array(
		'family'	=> rawurlencode(implode('|',$font_family)),
	);
	$font_url = add_query_arg($query_args,'//fonts.googleapis.com/css');
	return $font_url;
	$contents = wptt_get_webfont_url( esc_url_raw( $fonts_url ) );
}

//Enqueue scripts and styles.
function motivational_speaker_scripts() {
	// Add custom fonts, used in the main stylesheet.
	wp_enqueue_style( 'motivational-speaker-fonts', motivational_speaker_fonts_url(), array() );

	//Bootstarp
	wp_enqueue_style( 'bootstrap-style', get_template_directory_uri().'/assets/css/bootstrap.css' );

	// Theme stylesheet.
	wp_enqueue_style( 'motivational-speaker-style', get_stylesheet_uri() );

	wp_style_add_data('motivational-speaker-style', 'rtl', 'replace');

	// Theme Customize CSS.
	require get_parent_theme_file_path( 'inc/extra_customization.php' );
	wp_add_inline_style( 'motivational-speaker-style',$motivational_speaker_custom_style );

	//font-awesome
	wp_enqueue_style( 'font-awesome-style', get_template_directory_uri().'/assets/css/fontawesome-all.css' );

	// Block Style
	wp_enqueue_style( 'motivational-speaker-block-style', esc_url( get_template_directory_uri() ).'/assets/css/blocks.css' );

	//Custom JS
	wp_enqueue_script( 'motivational-speaker-custom.js', get_theme_file_uri( '/assets/js/theme-script.js' ), array( 'jquery' ), true );

	//Nav Focus JS
	wp_enqueue_script( 'motivational-speaker-navigation-focus', get_theme_file_uri( '/assets/js/navigation-focus.js' ), array( 'jquery' ), true );

	//Bootstarp JS
	wp_enqueue_script( 'bootstrap-js', get_theme_file_uri( '/assets/js/bootstrap.js' ), array( 'jquery' ),true );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}

	if (get_option('motivational_speaker_animation_enable', false) !== 'off') {
		//wow.js
		wp_enqueue_script( 'motivational-speaker-wow-js', get_theme_file_uri( '/assets/js/wow.js' ), array( 'jquery' ), true );

		//animate.css
		wp_enqueue_style( 'motivational-speaker-animate-css', get_template_directory_uri().'/assets/css/animate.css' );
	}
}
add_action( 'wp_enqueue_scripts', 'motivational_speaker_scripts' );

function motivational_speaker_block_editor_styles() {
	// Block styles.
	wp_enqueue_style( 'motivational-speaker-block-editor-style', trailingslashit( esc_url ( get_template_directory_uri() ) ) . '/assets/css/editor-blocks.css' );

	// Add custom fonts.
	wp_enqueue_style( 'motivational-speaker-fonts', motivational_speaker_fonts_url(), array() );
}
add_action( 'enqueue_block_editor_assets', 'motivational_speaker_block_editor_styles' );

# Load scripts and styles.(fontawesome)
add_action( 'customize_controls_enqueue_scripts', 'motivational_speaker_customize_controls_register_scripts' );
function motivational_speaker_customize_controls_register_scripts() {
	
	wp_enqueue_style( 'motivational-speaker-ctypo-customize-controls-style', trailingslashit( esc_url(get_template_directory_uri()) ) . '/assets/css/customize-controls.css' );
}

//enque files
require get_parent_theme_file_path( '/inc/custom-header.php' );
require get_parent_theme_file_path( '/inc/template-tags.php' );
require get_parent_theme_file_path( '/inc/template-functions.php' );
require get_parent_theme_file_path( '/inc/customizer.php' );
require get_parent_theme_file_path( '/inc/typofont.php' );
require get_parent_theme_file_path( '/inc/wptt-webfont-loader.php' );
require get_parent_theme_file_path( '/inc/breadcrumb.php' );
require get_parent_theme_file_path( 'inc/sortable/sortable_control.php' );